#include "iodefine.h"
//#include "RS232C.h"
//#include "common.h"
#include <stdarg.h>

/*VAʐM********************************************************************/
#define SCI_RB_SIZE 40  //Mobt@
typedef unsigned char BYTE;
typedef unsigned int UINT;
/*{[[g*/
enum brd{
CBR_115200 = 3,
CBR_57600 = 7,
CBR_38400 = 11,
CBR_19200 = 23,
CBR_14400 = 31,
CBR_9600 = 47,
CBR_4800 = 95,
CBR_2400 = 191,
};

/*peB*/
enum Parity{
even,
odd,
non
};
volatile BYTE sci_rxrb[SCI_RB_SIZE];
volatile BYTE scicombuff[SCI_RB_SIZE];

BYTE rb_rd_num;
BYTE rb_wr_num;

/******************************************************************/
/*                                                          */
/* VAʐMgpOɏKvB                       */
/* F@baudrate@F@{[[g̎wiL񋓎qwj   */
/*           parity@F@peB̐ݒiL񋓎qwj     */
/*             stop@F@Xgbvrbg̐ݒi0`2j           */
/* ߂lF                                                   */
/******************************************************************/
void InitSci3(BYTE baudrate,BYTE parity ,BYTE stop)
{
    UINT dmy;
    BYTE smr = 0;
    
    switch(parity){
        case even:
            smr = 0x20;
        break;
        case odd:
            smr = 0x30;
        break;
        case non:
        default:
            smr = 0x00;
        break;
    }
    if(stop == 2){
        smr |= 0x08;
    }
    
    SCI3.SCR3.BYTE = 0;       //رٺ۰ڼ޽(SCȊM/Mݒ)
    SCI3.SMR.BYTE = smr;       //رӰڼ޽(SCI̒ʐM̫ϯĂ̐ݒ)
    SCI3.BRR = (BYTE)baudrate;            //1bps
    
    for(dmy = 280;dmy > 0;dmy--); //Wait 1bit transfer time
    SCI3.SCR3.BYTE = 0x70;    //Enable Tx & Rx ,enable Rx interrupt
    IO.PMR1.BIT.TXD=1;
    SCI3.SSR.BYTE &= 0x80;   //Clear receive error flag
}


/******************************************************************/
/* 1oCgM                                                    */
/* VAʐM1oCgM֐B                            */
/* F@Mf[^                                             */
/* ߂lF@                                                 */
/******************************************************************/
void SciByteTx(BYTE data)
{
    
    SCI3.SCR3.BIT.TE=1;
    while(SCI3.SSR.BIT.TDRE!=1);

    SCI3.TDR=data;
    SCI3.SSR.BIT.TDRE = 0;
    while(SCI3.SSR.BIT.TEND!=1);
    SCI3.SCR3.BIT.TE=0;
}

/******************************************************************/
/* 񑗐M                                                     */
/* oroCgf[^̔z𑗐M֐B                     */
/* F@*strFM镶̃|C^                         */
/*     datalengFM镶                                   */
/* ߂lF@B                                               */
/******************************************************************/
void SciStrTx(BYTE *str,UINT dataleng)
{
    UINT i;
    
    SCI3.SCR3.BIT.TE=1;
    
    for(i=0;i<dataleng;i++)
        SciByteTx(str[i]);
}

/******************************************************************/
/* 1oCgM                                                    */
/* VAʐM1oCgM֐B                            */
/*iۂɂ̓obt@1oCĝݎĂj                   */
/* F@Mf[^ϐ̃|C^                       */
/* ߂lF 0Fobt@                                       */
/*          1Fobt@Ƀf[^L                               */
/******************************************************************/
BYTE SciByteRx(BYTE *data)
{
    if(rb_rd_num!=rb_wr_num)    //Mobt@󂶂Ȃ
    {   
        *data=sci_rxrb[rb_rd_num];
        rb_rd_num=(rb_rd_num+1)%SCI_RB_SIZE;
        return 1;
    }
    else    
        return 0;
}

void charput(char ch)
{
  int i;
  if(ch=='\n') SciByteTx('\r');
  SciByteTx(ch);
}

char charget()
{
  char ch;
  while(!SciByteRx((BYTE*)&ch));
  putchar(ch);    // GR[
  return ch;
}

/*
int vsprintf(char *_Restrict, const char *_Restrict, _Va_list);
*/
// ^o͂łȂ
int printf(const char *control, ...)
{
  char buf[256];
  va_list vargs;
  int n;
  va_start(vargs, control);
  vsprintf(buf, control, vargs);
  va_end(vargs);
  for(n=0; buf[n]; n++){
    charput(buf[n]);
  }
}


int putchar(char ch)
{
  SciByteTx(ch);
  if(ch==0x0d) SciByteTx(0x0a);
}

unsigned char getch()
{
  char ch;
  char status;
  status = SciByteRx((BYTE*)&ch);
  ch = (status != 0) ? ch : 0;
  return ch&0x7f;
}

char getchar()
{
  char ch;
  while(!SciByteRx((BYTE*)&ch));
  putchar(ch);    // GR[
  return ch;
  
}
#define UnitBytes 2
#define BUFLNG 80
char Buffer[BUFLNG];

// ő79bytẽf[^ǂݍ
// 󔒃LN^[I
void getline(char* str)
{
  int i;
  char ch, first=1;
  for(i = 0; i<BUFLNG-1; i++) {
    ch = getchar();
    // s󔒂͖
    if(first && (ch==0x0a || ch==0x20 || ch==0x09 || ch==0x0d)) continue;
    else first=0;
    if(ch==0x0a || ch==0x09 || ch==0x0d) break;
    // obNXy[XłP폜
    if(ch==0x08) {
      --str;
      putchar(' ');
      putchar(8);
    }
    else *str++=ch;
  }
  *str=0;
}


/************ Ȉscanf ***********************************
ϊd,x,c,ŝ݂łB
̐FXȎw͂łȂB
f~^̓Xy[XA^uAsłB
d: \iϊB
x: 16iϊB
c: ꕶ
s: 
************************************************************/
int scanf(char *format,...)
{
  char *cmd = (char*)&format+UnitBytes;   // 擪AhXɐݒ
  char *str, *ptr;
  char **addr;
  int *integer;
  int  x;
  static char buffer[80];
  char ch;
  int i, signFlag=1, errorFlag=0;
  str=buffer;

  getline(buffer);
  while(*format) {
    if(*format=='%') {
      switch(*++format) {
        case 'd':
          addr = (char**)cmd;
          integer = (int*)*addr;
          //getline(buffer);
          //str = buffer;
          while(*str==' ') str++;
          if(*str=='-') {
            signFlag=-1;
            str++;
          }
          x = 0;
          while(ch = *str) {
            if(('0'<=ch) && (ch<='9')) {
              x = x*10 + *str++ -'0';
            }
            else {
              errorFlag=-1;
              break;
            }
          }
          *integer = x*signFlag;
          cmd += sizeof(int*);
          signFlag=1;
          //;
          sprintf("[%d,%s]\n", x, str);         
          break;
        case 'x':
        case 'X':
          addr = (char**)cmd;
          integer = (int*)*addr;
          //getline(buffer);
          while(*str==' ') str++;
          //str = buffer;
          x = 0;
          while(ch = *str) {
            if(('0'<=ch) && (ch<='9')) {
               x = x*16 + ch -'0';
            }
            else {
              ch |= 0x20;     // ɕϊ
              if('a'<=ch && ch<='f') 
                x = x*16 + (ch -'a'+10);
              else {
                errorFlag=-1;
                break;
              }
            }
            str++;
          }
          *integer = x;
          cmd += sizeof(int*);
          break;
        case 'c': 
          addr = (char**)cmd;
          ptr = *addr;
          while(*str==' ') str++;
          //*ptr = getchar();
          *ptr = *str++;
          //while(!(*str=(char)inkey()));
          cmd += sizeof(char*);
          break;
        case 's': 
          addr = (char**)cmd;
          ptr = *addr;
          while(*str==' ') str++;
          for(i = 0; i<79; i++) {
            //ch = getchar();
            ch = *str++;
            if(ch==0x0d || ch==0x0a || ch==0x09) break;
            //putchar(*ptr);
            *ptr++ = ch;
            //putchar(ch);
           // putchar(*ptr++);
          }
          *ptr = 0;
          //putchar('\r');
          cmd += sizeof(char*);
          break;
      }
    }
    format++;
  }
//  putchar('\r');
//  putchar('\n');
  return errorFlag;
}
void LED(BYTE LedOn){
    IO.PCR6.BYTE |= 0x30;
    IO.PDR6.BIT.B4 = ~LedOn&0x01;
    IO.PDR6.BIT.B5 = (~LedOn>>1)&0x01;
}

// ꏊ
void abort(void){}
